/*
 * ULisp.java
 */

class ULisp extends ULisph {
    
    public static void main(String [] args) {
	
	System.out.println("Ulisp");
	System.out.println("Release 1.1 [2.14.98] - All writes reserved.");
	System.out.println("Level 1");
	init_atomes();
	init_read();
	init_stack();

	for(;;)
	    try {toplevel();}
	    catch(RuntimeException e) {
		init_read();
		init_stack();
	    }
    }

    public static void toplevel() {
	for(;;) {
	    System.out.print("->"); System.out.flush();
	    ULread.lisp_read();
	    ULeval.eval();
	    System.out.print("= ");
	    ULprint.lisp_print();
	    System.out.println();
	}
    }

    public static void err(String s) {
	System.out.println(s);
	throw new RuntimeException();
    }

    public static void init_stack() {
	Lstack.removeAllElements();
    }
    
    public static void init_read() {
	ULread.pos_read_buf = -1;
    }

    public static void init_atomes() {
	
	nil = cratom("nil"); setcval(nil, nil);
	undefined = cratom("undefined"); setcval(undefined, undefined);
	t = cratom("t"); setcval(t, t);
	quote = cratom("quote"); setcval(quote, quote);
	lambda = cratom("lambda"); setcval(lambda, lambda);

	for(int i = 0; i < p_temp_names.length; ++i) cratom(p_temp_names[i]);
    }

}



