/*
 * ULprint.java
 */

class ULprint extends ULisph {
    
    public static void lisp_print() {
	obj_print(a0);
    }

    public static void obj_print(Object obj) {
	if(is_at(obj)) {
	    System.out.print(((Atom)obj).pname); return;
	}
	if(is_int(obj)) {
	    System.out.print(val_int(obj)); return;
	}
	if(is_cons(obj)) {
	    list_print(obj); return;
	}
	err("Object a imprimer inconnu " + obj);
    }

    public static void list_print(Object obj) {
	System.out.print("(");
	for(;;) {
	    obj_print(car(obj));
	    if((obj = cdr(obj)) == nil) break;
	    System.out.print(" ");
	    if(is_cons(obj)) continue;
	    System.out.print(". "); obj_print(obj); break;
	}
	System.out.print(")");
    }
}
