/*
 * ULread.java
 */

import java.io.*;

class ULread extends ULisph {
    
    static String read_buf;
    static int pos_read_buf;
    static DataInputStream dis = new DataInputStream(System.in);
    
    public static void unread_char(char ch ) {
	--pos_read_buf;
    }

    public static char read_char() {
	char ch;
	if(pos_read_buf < 0) {
	    
	    try {read_buf = dis.readLine();}
	    catch(IOException e) {}
	    
	    read_buf += '\n';
	    pos_read_buf = 0;
	}
	ch = read_buf.charAt(pos_read_buf++);
	if(ch == '\n') pos_read_buf = -1;
	return (ch);
    }

    public static void lisp_read() {
	a0 = obj_read();
    }


    public static Object obj_read() {
	char ch;
	Object res = nil;

	do {ch = read_char();} while(is_separator(ch) || ch == ')');

	if(ch == '\'') res = cons(quote, cons(obj_read(), nil));
	else
	    if(Character.isDigit(ch)) res = int_read(ch);
	    else
		if(ch == '(') res = cons_read();
		else
		    if(Character.isLetter(ch)) res = atom_read(ch);
		    else err("Erreur read, caractere inconnu " + ch);
	return (res);
    }
    
    public static boolean is_separator(char ch) {
	return((ch == ' ' || ch == '\t' || ch == '\n') ? true : false);
    }
    
    public static Object int_read(char ch) {
	int val = 0;
	
	do {
	    val = val * 10 + Character.digit(ch, 10);
	    ch = read_char();
	} while (Character.isDigit(ch));

	unread_char(ch);
	return(make_int(val));
    }

    public static Object atom_read(char ch) {
	Object res;
	String name;
	String pname;
	StringBuffer atbuf = new StringBuffer();

	do {atbuf.append(ch); ch = read_char();}
	while(Character.isJavaLetterOrDigit(ch));
	unread_char(ch);
	pname = atbuf.toString();

	if(Lhashtable.containsKey(pname))
	    return((Object)Lhashtable.get(pname));;
	res = cratom(pname);
	return(res);
    }

    public static Object cons_read() {
	char ch; Object res, x;
	
	res = x = cons(nil, nil);
	for(;;) {
	    while(is_separator(ch = read_char()));
	    if(ch == ')') break;
	    unread_char(ch);
	    setcdr(x, cons(obj_read(), nil));
	    x = cdr(x);
	}
	return (cdr(res));
    }
}
